#include "file/interface/dfitem/dfitem_menu_choice.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemMenuChoice::CDFItemMenuChoice( tinyxml2::XMLDocument *doc ) : CDFItemBase( doc )
{
    xmlElement()->SetText( "ItemMenuChoice" );
}

CDFItemMenuChoice::~CDFItemMenuChoice()
{

}

int CDFItemMenuChoice::Modify( CModifyData &modifyData )
{
    int i;
    unsigned int offs = modifyData.offsFlash, offsChild;
    CDFItemBase *item = nullptr;
    StructOperating bedien;

    // Daten von MenueEintrag uebernehmen
    StructMenuItem &menuEintrag = *(StructMenuItem *)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    offs += sizeof( StructMenuItem );

    // Passwort ersetzen?
    if ( modifyData.flags & SMDF_PASSWORD_MENU )
    {
        short password = LookupPassword( modifyData, menuEintrag.name );
        if ( password != -1 )
        {
            menuEintrag.password = password;
        }
    }

    // Name aendern?
    strcpy( menuEintrag.name, LookupReplace( modifyData, menuEintrag.name ).c_str() );

    // Daten der Aktion einlesen
    // Bedien einlesen
    for ( i = 0; i < (int)menuEintrag.numberOfEntries; ++i )
    {
        // Bedien einlesen
        offsChild = offs + i * sizeof( unsigned int );	// Pointer des Eintrags berechnen
        offsChild = *(unsigned int *)(&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START]);
        ChangeOrderLong( (unsigned char *)&offsChild );

        bedien = *(StructOperating *)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];

        switch ( bedien.type )
        {

            case TB_MENUE:
            {
                item = new CDFItemMenu( xmlElement()->GetDocument() );
                break;
            }

            case TB_DATENSATZ:
            {
                item = new CDFItemInputChain( xmlElement()->GetDocument() );
                break;
            }
        }

        xmlElement()->InsertEndChild( item->xmlElement() );
        modifyData.offsFlash = offsChild;
        item->Modify( modifyData );
    }

    return 1;
}
